# <img src="https://github.com/pip-services/pip-services/raw/master/design/Logo.png" alt="Pip.Services Logo" style="max-width:30%"> 
# Component definitions for Dart

This framework is part of the [Pip.Services](https://github.com/pip-services/pip-services) project.
It defines standard component definitions that can be used to build applications and services:

- [**Auth**]() - authentication credential stores
- [**Build**]() - factories
- [**Cache**]() - distributed cache
- [**Component**]() - the root package
- [**Config**]() - configuration readers
- [**Connect**]() - connection discovery services
- [**Count**]() - performance counters
- [**Info**]() - context info
- [**Lock**]() - distributed locks
- [**Log**]() - logging components
- [**Test**]() - test components

- [**Component**]() - root package

Quick Links:

* [Downloads](https://github.com/pip-services3-dart/pip-services3-components-dart/blob/master/doc/Downloads.md)
* [API Reference](https://pub.dev/documentation/pip_services3_components/latest/pip_services3_components/pip_services3_components-library.html)
* [Building and Testing](https://github.com/pip-services3-dart/pip-services3-components-dart/blob/master/doc/Development.md)
* [Contributing](https://github.com/pip-services3-dart/pip-services3-components-dart/blob/master/doc/Development.md#contrib)
* [Examples](https://github.com/pip-services3-dart/pip-services3-components-dart/blob/master/example/README.md)


* Warning!
Config package now not work with condition **{{#if var}} something {{/}}** in config files.
Use **Mustache** syntax, for example **{{#var}} something {{/var}}**

## Acknowledgements

The library is created and maintained by **Sergey Seroukhov** and **Levichev Dmitry**.

The documentation is written by **Egor Nuzhnykh**, **Alexey Dvoykin**, **Mark Makarychev**, **Levichev Dmitry**.
